/* ============================ */
/* = DEFINITIONS :  ALTAZ.CPP = */
/* ============================ */
#include <stdio.h>
#include <io.h>
#include <iostream.h>
#include <iomanip.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <fcntl.h>
#include <math.h>

#define XNAME		"altaz"
#define VERSION     "1.1"
#define NB_ARG		21

#define LATITUDE 	0
#define LONGITUDE	1
#define AZIMUTH		2
#define HAUTEUR		3
#define IMG_SEC		4
#define IMG_TOT		5
#define CENTER_X	6
#define CENTER_Y	7
#define DIRECTORY	8
#define TRIGO		9
#define ECRAN		10
#define OFFSET		11
#define FOCALE		12
#define T_PIXEL		122
#define OBJET		13
#define JOUR		14
#define MOIS		15
#define ANNEE		16
#define HEURE		17
#define MINUTE		18
#define SECONDE		19
#define HELP		20

#define PI		3.1415926535898
#define ROT_HORAIRE	15.04106858 

#define SOLEIL		0
#define	LUNE		1
#define MERCURE		2
#define VENUS		3
#define MARS		4
#define JUPITER		5
#define SATURNE		6
#define URANUS		7
#define NEPTUNE		8

/* =============================== */
/* = STRUCTURE DONNEES DE CALCUL = */
/* =============================== */
struct ROT_STRUCT
{
 double lat, lon, asc, dec, az, ht, cx, cy, offs;
 float img, nimg;
 double f, p, b;
 double jj;
 int mm, aa, hrs, min;
 float sec;
 int obj;
 unsigned int trig, scr;
 char dir[255];
} rotation ;

/* =============================== */
/* = STRUCTURE CONVERSIONS  DMS  = */
/* =============================== */
struct DMS
{
	double d;
	double m;
	double s;
} f2dms ;

/* =============================== */
/* = STRUCTURE POSITION PLANETES = */
/* =============================== */
struct POSITION{
double  JJ,
  	t,  		// Temps sidral (en radian)
	Asc,	  	// Ascention droite (en radian)
	Dec, 		// Dclinaison (en radian)
	Hau,		// Hauteur
	Dist;	 	// Distance  la terre (en UA)
};

/* =========================== */
/* = PROTOTYPES DE FONCTIONS = */
/* =========================== */
double   deg2rad(double);
double   rad2deg(double);
float    rot_moy(float, float, float);
double   Int_Float(double);
int VerifyYearB(int);
int NbDaysFMonth(int , int);
double   Day2Float(float, float, float, float);
double   DMS2Float(int, unsigned int, unsigned int);
void     Float2DMS(double , struct DMS *);
double   JJ(double, int, int, int, int, float);
double   STG_H(struct ROT_STRUCT *);
POSITION CalculPosition(struct ROT_STRUCT *);
void     aff_hlp();
int      init_str(int, char *, struct ROT_STRUCT *);
void     trt_dta(struct ROT_STRUCT *);
void     raz_dta(struct ROT_STRUCT *);
float    b_max(float, float, float);
double RImage(struct ROT_STRUCT *);
